<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class RelMetaDia  {

    protected $RelMetaDiaService;
    protected $utilService;
    
    public function __construct(Services\RelMetaDiaService $RelMetaDiaService, Utilities\Util $utilService) {
        $this->RelMetaDiaService = $RelMetaDiaService;
        $this->utilService = $utilService;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        
        $conditions = $this->utilService->getParamsAsArray($request);
        $conditions = $this->buildParamsFaturamento($conditions);

        $result = $this->RelMetaDiaService->findMetaDia($conditions['CDFILIAL'], $conditions['DTENTRVENDAINI'], $conditions['DTENTRVENDAFIN'], $conditions['DIA'], $conditions['NRORG']);
        
        $response->addDataSet(new DataSet("vnd55018_relMetaDia", $result));
        
        return $response;
    }

    public function buildParamsFaturamento($conditions){
        $conditions['CDFILIAL'] = implode('_', $conditions['CDFILIAL']);
        
        if(array_key_exists('DTENTRVENDA', $conditions)) {
            $conditions['DTENTRVENDAINI'] = $conditions['DTENTRVENDA'][0];
            $conditions['DTENTRVENDAFIN'] = $conditions['DTENTRVENDA'][1];
            unset($conditions['DTENTRVENDA']);
        }
        if(array_key_exists('DIA', $conditions)) {
            $conditions['DIA'] = implode('_', $conditions['DIA']);
        }else{
            $conditions['DIA'] = '1_2_3_4_5_6_7';
        }
        return $conditions;
    }
}
