<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities\Query;

class Endereco {
	
	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}


	public function buscaBairro($NRORG, $CDPAIS, $SGESTADO, $CDMUNICIPIO){
		$params = array(
			':NRORG' => $NRORG,
			':CDPAIS'  => $CDPAIS,
			':SGESTADO' => $SGESTADO,
			':CDMUNICIPIO' => $CDMUNICIPIO
		);
		
		return $this->entityManager->getConnection()->fetchAll(Query::BUSCA_BAIRRO, $params);
	}
	
	public function buscaEnderecoPorCEP($NRORG, $NRCEP){
		$params = array(
			':NRORG' => $NRORG,
			':NRCEP' => $NRCEP
		);
		
		return $this->entityManager->getConnection()->fetchAll(self::BUSCA_ENDERECO_POR_CEP, $params);
	}

	

	// public function buscaConsCampanha($CDCAMPANHA, $CDCLIENTE, $DTINIVIGCAMP, $DTFIMVIGCAMP){
	// 	$params = array(
	// 		':CDCAMPANHA'   => $CDCAMPANHA,
	// 		':CDCLIENTE' 	=> $CDCLIENTE,
	// 		':DTINIVIGCAMP' => $DTINIVIGCAMP,
	// 		':DTFIMVIGCAMP' => $DTFIMVIGCAMP		
	// 	);
	// 	return $this->entityManager->getConnection()->fetchAll(Utilities\Query::DADOS_CONS_CAMPANHA, $params);
	// }
	
	const BUSCA_ENDERECO_POR_CEP = "
      SELECT P.CDPAIS, E.SGESTADO,
           M.CDMUNICIPIO, B.CDBAIRRO,
           P.NMPAIS, E.NMESTADO, 
           M.NMMUNICIPIO, B.NMBAIRRO, C.DSLOGCEP AS DSENDEVEN
           
    FROM CEP C 
    RIGHT JOIN PAIS P 
     ON C.CDPAIS = P.CDPAIS
    AND C.NRORG = P.NRORG
    
    RIGHT JOIN ESTADO E 
     ON C.SGESTADO = E.SGESTADO
    AND C.NRORG = E.NRORG
    
    RIGHT JOIN MUNICIPIO M 
     ON C.CDMUNICIPIO = M.CDMUNICIPIO
    AND C.NRORG = M.NRORG
    
    RIGHT JOIN BAIRRO B 
     ON C.CDBAIRRO = B.CDBAIRRO
    AND C.NRORG = B.NRORG
    
    WHERE C.NRORG = :NRORG 
    AND C.NRCEP = :NRCEP
    ";
}